<?php

/**
 * @file
 *
 * SOAP webservice implementation class using PHP's native SOAPClient class
 */

class CollectiveAccessSOAPConnector extends CollectiveAccessConnector {
  /**
   * Execute a method on the remote SOAP service
   */
  public function execute($service, $method, $params = array()) {
    if (isset($this->collectiveaccess_instance)) {
      $result = NULL;
      try {
        $service_url = $this->collectiveaccess_instance->service_url;
        $service_url .= '/' . drupal_strtolower($service);
        $service_url .= '/' . $service;
        $service_url .= '/soapWSDL';
        $client = new SoapClient($service_url);
        $result = call_user_func_array(array($client, $method), $params);
      } catch (SOAPFault $exception) {
        watchdog('collectiveaccess', 'SOAP ERROR @message', array('@message' => $exception->faultcode . ' ' . $exception->faultstring), WATCHDOG_ERROR);
      }
      return $result;
    }
    else {
      // @TODO: error handling
      return FALSE;
    }
  }

  public function get_type() {
    return 'SOAP';
  }
}